
long preheatDelay =                  40000;    // tube pre-heating delay
long rectifierDelay =                20000;    // rectifier pre-start delay
long inrushDelay =                    3000;    // inrush power delay
long overlapDelay =                    500;    // length of time between power on and inrush off


const int overvoltAlarm =                2;
const int PowerLED =                     4;
const int highVoltageLED =               6;
const int rectifierRelay =               7;
const int powerRelay =                   8;
const int inrushRelay =                  9;
const int preheatRelay =                10;
const int ACFailureAlarm =              11;
const int powerSwitch =                 12;
const int otherLED =                    14;

int powerButtonState                     ;
int lastPowerButtonState =           HIGH;

long lastDebounceTime =                 0;   
long debounceDelay =                   50;          //switch debounce delay
long previousMillis =                   0;
unsigned long currentMillis =           0;
long overlapValue =                     0;
long inrushStartTime;
long preheatStartTime;
long rectifierStartTime;
long powerStartTime;
int preheatOn =                         0;
int rectifierOn =                       0;
int inrushOn =                          0;
int powerOn =                           0;
int overlapOn =                         0;



void setup() {
  pinMode   (overvoltAlarm, INPUT_PULLUP);
  pinMode              (PowerLED, OUTPUT);
  pinMode        (highVoltageLED, OUTPUT);
  pinMode        (rectifierRelay, OUTPUT);
  pinMode            (powerRelay, OUTPUT);
  pinMode           (inrushRelay, OUTPUT);
  pinMode          (preheatRelay, OUTPUT);
  pinMode     (powerSwitch, INPUT_PULLUP);
  pinMode         (ACFailureAlarm, INPUT);
  pinMode              (otherLED, OUTPUT);


  Serial.begin                     (9600);             // start serial communication for debugging
}

void loop() {
  checkPowerButton();
  preheat();
  startRectifier();
  inrush();
  power();
  overlap();
  checkOverVoltage();
}

void checkOverVoltage() {
  int overvoltAlarmState = digitalRead (overvoltAlarm);
  if (overvoltAlarmState == LOW) {
    powerOff();
     Serial.println ("Over voltage Shut Down ");
  }
}




